﻿Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data

Module ListExtension

    <System.Runtime.CompilerServices.Extension> _
    Public Function ToDataTable(Of T)(data As IList(Of T)) As DataTable
        Dim d As [Double] = 1.0
        d.ToString()
        Dim properties As PropertyDescriptorCollection = TypeDescriptor.GetProperties(GetType(T))

        Dim table As New DataTable()

        For Each prop As PropertyDescriptor In properties
            table.Columns.Add(prop.Name, If(Nullable.GetUnderlyingType(prop.PropertyType), prop.PropertyType))
        Next

        For Each item As T In data
            Dim row As DataRow = table.NewRow()

            For Each prop As PropertyDescriptor In properties
                row(prop.Name) = If(prop.GetValue(item), DBNull.Value)
            Next

            table.Rows.Add(row)
        Next

        Return table
    End Function

    <System.Runtime.CompilerServices.Extension> _
    Public Function ToDataRow(Of T)(data As T) As DataRow
        Dim properties As PropertyDescriptorCollection = TypeDescriptor.GetProperties(GetType(T))

        Dim table As New DataTable()

        For Each prop As PropertyDescriptor In properties
            table.Columns.Add(prop.Name, If(Nullable.GetUnderlyingType(prop.PropertyType), prop.PropertyType))
        Next

        Dim row As DataRow = table.NewRow()

        For Each prop As PropertyDescriptor In properties
            row(prop.Name) = If(prop.GetValue(data), DBNull.Value)
        Next

        table.Rows.Add(row)

        Return table.Rows(0)
    End Function
End Module

